import 'dart:convert';
import 'dart:developer';
import 'dart:io';

import 'package:http/http.dart' as http;
import 'package:unit2/model/passo/bldg_loc.dart';
import 'package:unit2/utils/request.dart';
import 'package:unit2/utils/urls.dart';

class LocationLandrefServices {
  static final LocationLandrefServices _instance = LocationLandrefServices();
  static LocationLandrefServices get instance => _instance;

  String xClientKey = "unitK3CQaXiWlPReDsBzmmwBZPd9Re1z";
  String xClientKeySecret = "unitcYqAN7GGalyz";

  Future<http.Response?> update(BldgLoc data, id) async {
    String path = Url.instance.bldgLocation();
    Map<String, String> headers = {
      'Content-Type': 'application/json; charset=UTF-8',
      'X-Client-Key': xClientKey,
      'X-Client-Secret': xClientKeySecret
    };
    Map<String, String> params = {
      "bldgappr_details_id": id.toString(),
    };
    http.Response? response;
    try {
      http.Response response = await Request.instance
          .getRequest(param: params, path: path, headers: headers);
    } catch (e) {
      log(e.toString());
    }
    return response;
  }

  Future<BldgLoc> fetch(tempID) async {
    String path = Url.instance.bldgLocation();
    Map<String, String> headers = {
      'Content-Type': 'application/json; charset=UTF-8',
      'X-Client-Key': xClientKey,
      'X-Client-Secret': xClientKeySecret
    };
    Map<String, String> params = {
      "bldgappr_details_id": tempID.toString(),
    };
    try {
      http.Response response = await Request.instance
          .getRequest(param: params, path: path, headers: headers);

      print('BldgLocEdit');
      print(response.body);

      if (response.statusCode == 200) {
        final jsonData = jsonDecode(response.body);
        final dataList = jsonData['data'] as List<dynamic>;
        final result = BldgLoc.fromJson(dataList[0] as Map<String, dynamic>);

        return result;
      } else {
        print(response.reasonPhrase);
        throw Exception(response.reasonPhrase);
      }
    } catch (e) {
      throw e.toString();
    }
  }
}
